require 'open-uri'
require 'json'

class ClHttpPull
# Class constructor
def initialize( url, downloadLocalPath = __dir__ , nextFileIndex = 0 )
    # Instance variables
    @url = 'http://' + url
    @nextFileIndex = nextFileIndex
    @downloadLocalPath = downloadLocalPath
    @fileList = Array.new()
end

# Update file list
def getFileList()
    begin
        reply = open( @url + '/SD_WLAN/json.lua' ) { |io| io.read }
        @fileList = JSON.parse( reply )
        isConnected = true
    rescue
        @fileList.clear
        isConnected = false
    end
    return {:result => isConnected, :fileList => @fileList}
end

# Pull files to local folder
def pullLogFiles()

    # Update file list
    self.getFileList()

    # Get list of new log files
    filterFileList = @fileList.select {|file| file["name"][0..-5].to_i > @nextFileIndex }

    pullResult = Array.new()
    filterFileList.each do |file|
        begin
            open(@url + '/' + file["name"], 'rb') do |inFile|
                File.open( @downloadLocalPath + '/' +  file["name"], 'wb') do |outFile|
                    IO.copy_stream(inFile, outFile)
                end
            end
            pullResult << {:name => file["name"], :result => true}
        rescue
            pullResult << {:name => file["name"], :result => false}
        end
    end
    return pullResult
end
end